#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include "PRINT.h"
using namespace std;

bool durch3teilbar (int elem)
{
    return elem % 3 == 0;
}

class summeGroesserAls {
  private:
    int max;
    int summe;
  public:
    summeGroesserAls (int m) : max(m), summe(0) {
    }
    bool operator() (int elem) {
        summe += elem;
        return summe > 10;
    }
};

int main()
{
    vector<int> menge;
    vector<int>::iterator pos;

    /* Elemente 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_back(i);
    }

    PRINT ("menge: ", menge);

    /* erstes Element mit Wert groesser als 3 finden
     */
    pos = find_if (menge.begin(), menge.end(),
                   bind2nd(greater<int>(),3));

    /* ab da alle Element ausgeben
     */
    cout << "ab Wert>3: ";
    copy (pos, menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* erstes durch 3 teilbares Element finden
     */
    pos = find_if (menge.begin(), menge.end(),
                   durch3teilbar);

    /* ab da alle Element ausgeben
     */
    cout << "ab durch 3 teilbarem Wert: ";
    copy (pos, menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* erstes Element finden, mit dem die Summe aller Elemente
     * groesser als 10 ist
     */
    pos = find_if (menge.begin(), menge.end(),
                   summeGroesserAls(10));

    /* ab da alle Element ausgeben
     */
    cout << "ab Summe>10: ";
    copy (pos, menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
