#include <iostream>
#include <list>
#include <vector>
#include <algorithm>
using namespace std;

/* printMenge()
 *  - list<int> ausgeben
 */
void printMenge (const list<int>& l)
{
    copy (l.begin(), l.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}

/* lessMenge()
 *  - list<int> "lexikalisch" mit list<int> vergleichen
 */
bool lessMenge (const list<int>& l1, const list<int>& l2)
{
    return lexicographical_compare (l1.begin(), l1.end(),
                                    l2.begin(), l2.end());
}

int main()
{
    /* vier Mengen
     */
    list<int> m1, m2, m3, m4;

    /* erstmal ueberall Elemente  1 bis 5 einfuegen
     */
    for (int i=1; i<=5; i++) {
        m1.push_back(i);
    }
    m4 = m3 = m2 = m1;

    /* dann ein paar Unterschiede
     */
    m1.push_back (7);
    m3.push_back (2);
    m3.push_back (0);
    m4.push_back (2);

    /* Menge von Mengen bilden
     */
    vector<list<int > > mm;

    mm.push_back(m1);
    mm.push_back(m2);
    mm.push_back(m3);
    mm.push_back(m4);
    mm.push_back(m3);
    mm.push_back(m1);
    mm.push_back(m4);
    mm.push_back(m2);

    /* Menge von Mengen ausgeben
     */
    for_each (mm.begin(), mm.end(), printMenge);
    cout << endl;

    /* Menge umgekehrt sortieren
     *  - verwendet: lexicographical_compare()
     */
    sort (mm.begin(), mm.end(), lessMenge);

    /* Menge von Mengen wieder ausgeben
     */
    for_each (mm.begin(), mm.end(), printMenge);
}
