#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void print (int elem)
{
    cout << elem << ' ';
}

int main()
{
    vector<int> menge;

    /* Back-Insert-Iterator fuer menge erzeugen
     */
    back_insert_iterator<vector<int> > iter(menge);

    /* Elemente mit Back-Insert-Iterator einfuegen
     */
    iter = 1;
    iter = 2;
    iter = 3;

    /* Elemente ausgeben
     */
    for_each (menge.begin(), menge.end(),    // Bereich
              print);                        // Operation
    cout << endl;

    /* Back-Insert-Iterator als Back-Inserter erzeugen
     */
    back_inserter(menge) = 55;

    /* Elemente ausgeben
     */
    for_each (menge.begin(), menge.end(),    // Bereich
              print);                        // Operation
    cout << endl;

    /* copy() mit Back-Inserter zum 
     * Anhaengen von Elementen
     */
    copy (menge.begin(), menge.end(),        // Quellbereich
          back_inserter(menge));             // Zielbereich

    /* Elemente ausgeben
     */
    for_each (menge.begin(), menge.end(),    // Bereich
              print);                        // Operation
    cout << endl;
}
