#include <iostream>
#include <list>
#include <algorithm>
using namespace std;

void print (int elem)
{
    cout << elem << ' ';
}

int main()
{
    list<int> menge;

    /* Front-Insert-Iterator fuer menge erzeugen
     */
    front_insert_iterator<list<int> > iter(menge);

    /* Elemente mit Front-Insert-Iterator einfuegen
     */
    iter = 1;
    iter = 2;
    iter = 3;

    /* Elemente ausgeben
     */
    for_each (menge.begin(), menge.end(),    // Bereich
              print);                        // Operation
    cout << endl;

    /* Front-Insert-Iterator als Front-Inserter erzeugen
     */
    front_inserter(menge) = 55;

    /* Elemente ausgeben
     */
    for_each (menge.begin(), menge.end(),    // Bereich
              print);                        // Operation
    cout << endl;

    /* Front-Inserter beim Copy-Algorithmus
     * zum "vorne Einfuegen" von Elementen
     */
    list<int> menge2;
    copy (menge.begin(), menge.end(),        // Quellbereich
          front_inserter(menge2));           // Zielbereich

    /* Elemente ausgeben
     */
    for_each (menge2.begin(), menge2.end(),  // Bereich
              print);                        // Operation
    cout << endl;
}
