#include <iostream>
#include <complex>
using namespace std;

int main()
{
    /* Komplexe Zahl aus Real- und Imaginaerteil
     *  Realteil: 4.0   Imaginaerteil: 3.0
     */
    complex<double> c1(4.0,3.0);

    /* Komplexe Zahl aus Polarkoordinaten:
     *  Laenge: 5.0   Winkel: 0.75 (im Bogenmass)
     */
#ifdef __GNUC__
    complex<float> c2 = complex<float>(polar(5.0,0.75));
#else
    complex<float> c2 = polar(5.0,0.75);
#endif

    cout << "c1: " << c1 << endl;
    cout << "c2: " << c2 << endl;

    cout << "c1: Laenge: " << abs(c1) << " (Norm: " << norm(c1) << ") "
         <<    " Winkel: " << arg(c1) << endl;
    cout << "c2: Laenge: " << abs(c2) << " (Norm: " << norm(c2) << ") "
         <<    " Winkel: " << arg(c2) << endl;

    cout << "c1 konjugiert:  " << conj(c1) << endl;
    cout << "c2 konjugiert:  " << conj(c2) << endl;

    cout << "4.4 + c1 * 1.8: " << 4.4 + c1 * 1.8 << endl;

    /* Summe von c1 und c2:
     *  - beachte: verschiedene Typen
     */
    cout << "c1 + c2:        "
         << c1 + complex<double>(c2.real(),c2.imag()) << endl;

    cout << "c1 += sqrt(c1): " << (c1 += sqrt(c1)) << endl;
}
