#include <iostream>
#include <valarray>
using namespace std;

/* Valarray ausgeben
 *  - "size" war frueher "length"
 */
template <class T>
void printValarray (const valarray<T>& va)
{
    for (int i=0; i<va.size(); i++) {
        cout << va[i] << ' ';
    }
    cout << endl;
}

int main()
{
    /* Valarray fuer 10 Elemente anlegen und 0.0 bis 9.9 zuweisen
     */
    valarray<double> va(10);
    for (int i=0; i<10; i++) {
        va[i] = i * 1.1;
    }

    /* Valarray ausgeben
     */
    printValarray (va);

    /* Werte im Valarray verdoppeln
     */
    va *= 2.0;

    /* Valarray wieder ausgeben
     */
    printValarray (va);

    /* zweites Valarray erzeugen und mit den um 10 erhoehten Elementen
     * vom ersten Valarray initialisieren
     */
    valarray<double> vb(va+10.0);

    /* zweites Valarray ausgeben
     */
    printValarray (vb);

    /* drittes Valarray erzeugen und Werte aus
     * Verknuepfung zuweisen
     */ 
    valarray<double> vc;
    vc = sqrt(va) + vb/2.0 - 1.0;
    
    /* drittes Valarray ausgeben
     */
    printValarray (vc);
}
